local RayUI, E, L, V, P, G = unpack(select(2, ...))
if IsAddOnLoaded("ElvUI_FCT") ~= true then return end

local _G, string = _G, string
local IsAddOnLoaded = IsAddOnLoaded

local addon = "ElvUI_FCT"
local FCT = E.Libs.AceAddon:GetAddon(addon)

function RayUI:LoadFCTProfile()	
	_G.ElvFCT = {
		["nameplates"] = {
			["frames"] = {
				["Player"] = {
					["font"] = "PT Sans Narrow",
				},
				["EnemyNPC"] = {
					["fontSize"] = 20,
					["advanced"] = {
						["radius"] = 120,
						["OffsetX"] = 0,
						["OffsetY"] = 15,
						["anim"] = "vertical",
					},
					["textShake"] = true,
					["iconSize"] = 22,
					["font"] = "PT Sans Narrow",
					["showDots"] = true,
					["numberStyle"] = "BLIZZARD",
					["shakeDuration"] = 0.3,
				},
				["FriendlyPlayer"] = {
					["font"] = "PT Sans Narrow",
				},
				["EnemyPlayer"] = {
					["fontSize"] = 20,
					["advanced"] = {
						["radius"] = 120,
						["OffsetX"] = 0,
						["OffsetY"] = 15,
						["anim"] = "vertical",
					},
					["iconSize"] = 22,
					["font"] = "PT Sans Narrow",
					["showDots"] = true,
					["numberStyle"] = "BLIZZARD",
					["shakeDuration"] = 0.3,
				},
				["FriendlyNPC"] = {
					["font"] = "PT Sans Narrow",
				},
			},
		},
		["colors"] = {
			["-3"] = {
				["g"] = 0.78,
			},
			["01"] = {
				["r"] = 0.78,
			},
		},
		["unitframes"] = {
			["frames"] = {
				["Target"] = {
					["textY"] = 2,
					["iconX"] = -3,
					["advanced"] = {
						["anim"] = "vertical",
					},
					["showIcon"] = true,
					["alternateIcon"] = true,
					["showName"] = false,
					["numberStyle"] = "BLIZZARD",
					["font"] = "PT Sans Narrow",
				},
				["Pet"] = {
					["advanced"] = {
						["OffsetY"] = 25,
						["anim"] = "vertical",
					},
					["showIcon"] = true,
					["mode"] = "LS",
					["alternateIcon"] = true,
					["font"] = "PT Sans Narrow",
					["numberStyle"] = "BLIZZARD",
				},
				["Player"] = {
					["iconX"] = 0,
					["advanced"] = {
						["radius"] = 120,
						["OffsetX"] = 0,
						["OffsetY"] = 30,
						["anim"] = "vertical",
					},
					["showIcon"] = true,
					["iconSize"] = 22,
					["mode"] = "LS",
					["isPlayer"] = false,
					["showHots"] = true,
					["alternateIcon"] = true,
					["spellY"] = 0,
					["showName"] = false,
					["showDots"] = true,
					["numberStyle"] = "BLIZZARD",
					["font"] = "PT Sans Narrow",
					["fontSize"] = 20,
				},
			},
		},
	}
	FCT:Initialize()
end

local function ElvUI_FCTTable()
	E.Options.args.rayui.args.addons.args[addon] = {
		order = 1,
		type = "execute",
		name = addon,
		desc = string.format(L["This will create and apply profile for %s"], addon),
		buttonElvUI = true,
		func = function()
			RayUI:LoadFCTProfile()
			FCT:UpdateUnitFrames()
			FCT:UpdateNamePlates()
			-- RayUI:Print(profileString..addon)
		end,
		disabled = function() return not IsAddOnLoaded(addon) end,
	}
end

tinsert(RayUI.Config, ElvUI_FCTTable)
