local RayUI, E, L, V, P, g = unpack(select(2, ...))
local RCH = RayUI:GetModule('RayUIChat')

local function ChatTable()
	E.Options.args.rayui.args.modules.args.chat = {
		type = "group",
		name = E.NewSign..L["Chat"],
		get = function(info) return E.db.rayui.chat[ info[#info] ] end,
		set = function(info, value) E.db.rayui.chat[ info[#info] ] = value; RCH:Configure_All(); end,
		args = {
			name = {
				order = 1,
				type = "header",
				name = L["Chat"],
			},
			autohide = {
				order = 2,
				type = "group",
				name = L["Auto hide"],
				guiInline = true,
				get = function(info) return E.db.rayui.chat[ info[#info] ] end,
				set = function(info, value) E.db.rayui.chat[ info[#info] ] = value; RCH:Configure_AutoHide(); end,
				args = {
					autoHide = {
						order = 1,
						type = "toggle",
						name = L["Enable"],
						desc = L["Enable chat panel auto hide"],
					},
					autoHideTimeout = {
						order = 2,
						type = "range",
						min = 5, max = 60, step = 1,
						name = L["Auto hide timeout"],
						desc = L["Seconds before hiding chat panel"],
						disabled = function() return not E.db.rayui.chat.autoHide end
					},
				},
			},
		},
	}
end

tinsert(RayUI.Config, ChatTable)
