local RayUI, E, _, V, P, g = unpack(select(2, ...))
local RUF = RayUI:GetModule('RayUIUnitframes')
local UF = E.UnitFrames

--Cache global variables
--Lua functions
--WoW API / Variables
local _G, pairs, hooksecurefunc = _G, pairs, hooksecurefunc
local UnitIsConnected = UnitIsConnected
local UnitHealthMax = UnitHealthMax
-- GLOBALS:

function RUF:Configure_HealComm(frame)
	if frame.db.healPrediction and frame.db.healPrediction.enable and frame.db.health then
		local healPrediction = frame.HealthPrediction
		
		if healPrediction.absorbBar and not healPrediction.absorbBar.overlay then
			healPrediction.absorbBar.overlay = healPrediction.absorbBar:CreateTexture(nil, "ARTWORK", nil, 1)
			healPrediction.absorbBar.overlay:SetAllPoints(healPrediction.absorbBar:GetStatusBarTexture())
			healPrediction.absorbBar.overlay:SetTexture("Interface\\RaidFrame\\Shield-Overlay", true, true)
			healPrediction.absorbBar.overlay.tileSize = 32
		end
	end
end

function RUF:UpdateHealComm(unit, myIncomingHeal, otherIncomingHeal, absorb, healAbsorb, hasOverAbsorb, hasOverHealAbsorb)
	if not self.absorbBar.overlay or not UnitIsConnected(unit) then return end

	local pred = self.frame and self.frame.db and self.frame.db.healPrediction
	local totalWidth, totalHeight = self.frame.Health:GetSize()
	local totalMax = UnitHealthMax(unit)
	absorb = pred and UnitGetTotalAbsorbs(unit) or absorb
	local barSize = (absorb / totalMax) * totalWidth
	self.absorbBar.overlay:SetTexCoord(0, barSize / self.absorbBar.overlay.tileSize, 0, totalHeight / self.absorbBar.overlay.tileSize)
end

function RUF:UpdatePredictionStatusBar(prediction, parent, name)
	if not (prediction and parent) then return end
	if name == "Health" then
		self:Configure_HealComm(parent:GetParent())
	end
end

function RUF:LoadHealPrediction()
	if E.private.unitframe.enable ~= true then return end

	hooksecurefunc(UF, "Configure_HealComm", RUF.Configure_HealComm)
	hooksecurefunc(UF, "UpdatePredictionStatusBar", RUF.UpdatePredictionStatusBar)

	for _, object in pairs(_G.ElvUF.objects) do
        if object.HealthPrediction and object.HealthPrediction.PostUpdate then
			hooksecurefunc(object.HealthPrediction, "PostUpdate", RUF.UpdateHealComm)
		end
    end
end
